searchNodes=[{"doc":"Generate Elixir code from .proto files. Example: mix protox.generate --output-path=lib/message.ex --include-path=. message.proto The generated file will be usable in any project as long as protox is declared in the dependencies (the generated file still needs functions from the protox runtime). You can use the --namespace option to prepend a namespace to all generated modules. If you have large protobuf files, you can use the --multiple-files option to generate one file per module. Finally, you can pass the option --keep-unknown-fields=false to remove support of unknown fields.","ref":"Mix.Tasks.Protox.Generate.html","title":"Mix.Tasks.Protox.Generate","type":"task"},{"doc":"Use this module to generate the Elixir structs corresponding to a set of protobuf definitions and to encode/decode instances of these structures. Elixit structs generation examples From a set of files: defmodule Dummy do use Protox , files : [ &quot;./defs/foo.proto&quot; , &quot;./defs/bar.proto&quot; , &quot;./defs/baz/fiz.proto&quot; , ] end From a string: defmodule Dummy do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; package fiz; message Baz { } message Foo { map&lt;int32, Baz&gt; b = 2; } &quot;&quot;&quot; end The generated modules respect the package declaration. For instance, in the above example, both the Fiz.Baz and Fiz.Foo modules will be generated. Encoding/decoding For the rest of this module documentation, we suppose the following protobuf messages are defined: defmodule Dummy do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; package fiz; message Baz { } enum Enum { FOO = 0; BAR = 1; } message Foo { Enum a = 1; map&lt;int32, Baz&gt; b = 2; } &quot;&quot;&quot; , namespace : Namespace use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Msg { map&lt;int32, string&gt; msg_k = 8; } &quot;&quot;&quot; use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Sub { int32 a = 1; } &quot;&quot;&quot; end See each function documentation to see how they are used to encode and decode protobuf messages.","ref":"Protox.html","title":"Protox","type":"module"},{"doc":"Decode a binary into a protobuf message. Examples iex&gt; binary = &lt;&lt; 66 , 7 , 8 , 1 , 18 , 3 , 102 , 111 , 111 , 66 , 7 , 8 , 2 , 18 , 3 , 98 , 97 , 114 &gt;&gt; iex&gt; { :ok , msg } = Protox . decode ( binary , Msg ) iex&gt; msg % Msg { msg_k : %{ 1 =&gt; &quot;foo&quot; , 2 =&gt; &quot;bar&quot; } } iex&gt; binary = &lt;&lt; 66 , 7 , 8 , 1 , 18 , 3 , 102 , 111 , 66 , 7 , 8 , 2 , 18 , 3 , 98 , 97 , 114 &gt;&gt; iex&gt; { :error , reason } = Protox . decode ( binary , Msg ) iex&gt; reason % Protox.IllegalTagError { message : &quot;Field with illegal tag 0&quot; }","ref":"Protox.html#decode/2","title":"Protox.decode/2","type":"function"},{"doc":"Throwing version of decode/2 .","ref":"Protox.html#decode!/2","title":"Protox.decode!/2","type":"function"},{"doc":"Encode a protobuf message into IO data. Examples iex&gt; msg = % Namespace.Fiz.Foo { a : 3 , b : %{ 1 =&gt; % Namespace.Fiz.Baz { } } } iex&gt; { :ok , iodata } = Protox . encode ( msg ) iex&gt; :binary . list_to_bin ( iodata ) &lt;&lt; 8 , 3 , 18 , 4 , 8 , 1 , 18 , 0 &gt;&gt; iex&gt; msg = % Namespace.Fiz.Foo { a : &quot;should not be a string&quot; } iex&gt; { :error , reason } = Protox . encode ( msg ) iex&gt; reason % Protox.EncodingError { field : :a , message : &quot;Could not encode field :a (invalid field value)&quot; }","ref":"Protox.html#encode/1","title":"Protox.encode/1","type":"function"},{"doc":"Throwing version of encode/1 .","ref":"Protox.html#encode!/1","title":"Protox.encode!/1","type":"function"},{"doc":"Errors This function returns a tuple {:error, reason} if: input could not be decoded to JSON; reason is a Protox.JsonDecodingError error JSON library configuration The default library to decode JSON is Jason . However, you can chose to use Poison : iex&gt; Protox . json_decode ( &quot;{ \\&quot; a \\&quot; : \\&quot; BAR \\&quot; }&quot; , Namespace.Fiz.Foo , json_decoder : Poison ) { :ok , % Namespace.Fiz.Foo { __uf__ : [ ] , a : :BAR , b : %{ } } } You can also use another library as long as it exports an decode! function. You can easily create a module to wrap a library that would not have this interface (like jiffy ): defmodule Jiffy do def decode! ( input ) do :jiffy . decode ( input , [ :return_maps , :use_nil ] ) end end","ref":"Protox.html#json_decode/3","title":"Protox.json_decode/3","type":"function"},{"doc":"Throwing version of json_decode/2 .","ref":"Protox.html#json_decode!/3","title":"Protox.json_decode!/3","type":"function"},{"doc":"Export a proto3 message to JSON as IO data. Errors This function returns a tuple {:error, reason} if: msg could not be encoded to JSON; reason is a Protox.JsonEncodingError error Examples iex&gt; msg = % Namespace.Fiz.Foo { a : :BAR } iex&gt; { :ok , iodata } = Protox . json_encode ( msg ) iex&gt; iodata [ &quot;{&quot; , [ &quot; \\&quot; a \\&quot; &quot; , &quot;:&quot; , &quot; \\&quot; BAR \\&quot; &quot; ] , &quot;}&quot; ] iex&gt; msg = % Sub { a : 42 } iex&gt; { :ok , iodata } = Protox . json_encode ( msg ) iex&gt; iodata [ &quot;{&quot; , [ &quot; \\&quot; a \\&quot; &quot; , &quot;:&quot; , &quot;42&quot; ] , &quot;}&quot; ] iex&gt; msg = % Msg { msg_k : %{ 1 =&gt; &quot;foo&quot; , 2 =&gt; &quot;bar&quot; } } iex&gt; { :ok , iodata } = msg |&gt; Protox . json_encode ( ) iex&gt; :binary . list_to_bin ( iodata ) &quot;{ \\&quot; msgK \\&quot; :{ \\&quot; 2 \\&quot; : \\&quot; bar \\&quot; , \\&quot; 1 \\&quot; : \\&quot; foo \\&quot; }}&quot; JSON library configuration The default library to encode values (i.e. mostly to escape strings) to JSON is Jason . However, you can chose to use Poison : iex&gt; msg = % Namespace.Fiz.Foo { a : :BAR } iex&gt; Protox . json_encode ( msg , json_encoder : Poison ) { :ok , [ &quot;{&quot; , [ &quot; \\&quot; a \\&quot; &quot; , &quot;:&quot; , &quot; \\&quot; BAR \\&quot; &quot; ] , &quot;}&quot; ] } You can also use another library as long as it exports an encode! function, which is expected to return objects as maps and nil to represent null . You can easily create a module to wrap a library that would not have this interface (like jiffy ): defmodule Jiffy do defdelegate encode! ( msg ) , to : :jiffy , as : :encode end Encoding specifications See https://developers.google.com/protocol-buffers/docs/proto3#json for the specifications of the encoding.","ref":"Protox.html#json_encode/2","title":"Protox.json_encode/2","type":"function"},{"doc":"Throwing version of json_encode/1 .","ref":"Protox.html#json_encode!/2","title":"Protox.json_encode!/2","type":"function"},{"doc":"Default values of Protocol Buffers types. Note that generated structs contain a default/1 function to return the default value of a field using its name.","ref":"Protox.Default.html","title":"Protox.Default","type":"module"},{"doc":"Returns the default value of a Protocol Buffer type specified with an atom. Examples iex&gt; Protox.Default . default ( :bool ) false iex&gt; Protox.Default . default ( :string ) &quot;&quot;","ref":"Protox.Default.html#default/1","title":"Protox.Default.default/1","type":"function"},{"doc":"This module contains the functions necessary to encode protobuf messages.","ref":"Protox.Encode.html","title":"Protox.Encode","type":"module"},{"doc":"Encode a protobuf message into IO data. Example msg = % Fiz.Foo { a : 3 , b : %{ 1 =&gt; % Fiz.Baz { } } } { :ok , iodata } = Protox.Encode . encode ( msg )","ref":"Protox.Encode.html#encode/1","title":"Protox.Encode.encode/1","type":"function"},{"doc":"Throwing version of encode/1 .","ref":"Protox.Encode.html#encode!/1","title":"Protox.Encode.encode!/1","type":"function"},{"doc":"The definition of a protobuf field (e.g. tag, type, etc.).","ref":"Protox.Field.html","title":"Protox.Field","type":"module"},{"doc":"","ref":"Protox.Field.html#t:t/0","title":"Protox.Field.t/0","type":"type"},{"doc":"The behaviour to implement when wrapping a JSON library.","ref":"Protox.JsonLibrary.html","title":"Protox.JsonLibrary","type":"behaviour"},{"doc":"Should wrap any exception of the underlying library in Protox.JsonDecodingError.","ref":"Protox.JsonLibrary.html#c:decode!/2","title":"Protox.JsonLibrary.decode!/2","type":"callback"},{"doc":"Should wrap any exception of the underlying library in Protox.JsonEncodingError.","ref":"Protox.JsonLibrary.html#c:encode!/2","title":"Protox.JsonLibrary.encode!/2","type":"callback"},{"doc":"","ref":"Protox.JsonLibrary.html#c:load/0","title":"Protox.JsonLibrary.load/0","type":"callback"},{"doc":"This protocol makes possible to override the JSON decoding of a specific message.","ref":"Protox.JsonMessageDecoder.html","title":"Protox.JsonMessageDecoder","type":"protocol"},{"doc":"","ref":"Protox.JsonMessageDecoder.html#decode_message/2","title":"Protox.JsonMessageDecoder.decode_message/2","type":"function"},{"doc":"","ref":"Protox.JsonMessageDecoder.html#t:t/0","title":"Protox.JsonMessageDecoder.t/0","type":"type"},{"doc":"This protocol makes possible to override the JSON encoding of a specific message. For instance, it's possible to encode Google.Protobuf.Duration as a string rather than an object as required by the JSON encoding specification .","ref":"Protox.JsonMessageEncoder.html","title":"Protox.JsonMessageEncoder","type":"protocol"},{"doc":"The contract of a message encoder. msg is the protobuf message to encode json_encode is the function to use in the protocol implementation to encode values to JSON","ref":"Protox.JsonMessageEncoder.html#encode_message/2","title":"Protox.JsonMessageEncoder.encode_message/2","type":"function"},{"doc":"","ref":"Protox.JsonMessageEncoder.html#t:t/0","title":"Protox.JsonMessageEncoder.t/0","type":"type"},{"doc":"This module provides a helper function to merge messages.","ref":"Protox.MergeMessage.html","title":"Protox.MergeMessage","type":"module"},{"doc":"Singular fields of msg will be overwritten, if specified in from , except for embedded messages which will be merged. Repeated fields will be concatenated. Note that &quot;specified&quot; has a different meaning in protobuf 2 and 3: 2: if the singular field from from is nil, the value from msg is kept 3: if the singular field from from is set to the default value, the value from msg is kept. This behaviour matches the C++ reference implementation behaviour. msg and from must be of the same type; or either msg or from is nil : the non-nil message is returned; or both are nil : nil is returned Example iex&gt; r1 = % Protobuf2 { a : 0 , s : :ONE } iex&gt; r2 = % Protobuf2 { a : nil , s : :TWO } iex&gt; Protox.MergeMessage . merge ( r1 , r2 ) % Protobuf2 { a : 0 , s : :TWO } iex&gt; Protox.MergeMessage . merge ( r2 , r1 ) % Protobuf2 { a : 0 , s : :ONE }","ref":"Protox.MergeMessage.html#merge/2","title":"Protox.MergeMessage.merge/2","type":"function"},{"doc":"This module describes types that define a protobuf message. See https://developers.google.com/protocol-buffers/docs/encoding#structure.","ref":"Protox.Types.html","title":"Protox.Types","type":"module"},{"doc":"This type give more details on how a field is encoded.","ref":"Protox.Types.html#t:kind/0","title":"Protox.Types.kind/0","type":"type"},{"doc":"This type gives more information on the field presence (if applicable).","ref":"Protox.Types.html#t:label/0","title":"Protox.Types.label/0","type":"type"},{"doc":"All types that can be used as a key in map field.","ref":"Protox.Types.html#t:map_key_type/0","title":"Protox.Types.map_key_type/0","type":"type"},{"doc":"The wire type of a field: it tells how a field is encoded (32 or 64 bits scalar, repeated or variable-length integer).","ref":"Protox.Types.html#t:tag/0","title":"Protox.Types.tag/0","type":"type"},{"doc":"All types that can be stored in a protobuf message.","ref":"Protox.Types.html#t:type/0","title":"Protox.Types.type/0","type":"type"},{"doc":"32 bits scalar.","ref":"Protox.Types.html#t:wire_32bits/0","title":"Protox.Types.wire_32bits/0","type":"type"},{"doc":"64 bits scalar.","ref":"Protox.Types.html#t:wire_64bits/0","title":"Protox.Types.wire_64bits/0","type":"type"},{"doc":"Repeated field.","ref":"Protox.Types.html#t:wire_delimited/0","title":"Protox.Types.wire_delimited/0","type":"type"},{"doc":"Variable length integer.","ref":"Protox.Types.html#t:wire_varint/0","title":"Protox.Types.wire_varint/0","type":"type"},{"doc":"This error is thrown when a data could not be decoded.","ref":"Protox.DecodingError.html","title":"Protox.DecodingError","type":"exception"},{"doc":"This error is thrown when a message could not be encoded.","ref":"Protox.EncodingError.html","title":"Protox.EncodingError","type":"exception"},{"doc":"This error is thrown when decoding data with a field which tag is 0.","ref":"Protox.IllegalTagError.html","title":"Protox.IllegalTagError","type":"exception"},{"doc":"This error is thrown when a field is constructed with an invalid atribute.","ref":"Protox.InvalidFieldAttribute.html","title":"Protox.InvalidFieldAttribute","type":"exception"},{"doc":"This error is thrown when a JSON payload could not be decoded to a protobuf message.","ref":"Protox.JsonDecodingError.html","title":"Protox.JsonDecodingError","type":"exception"},{"doc":"This error is thrown when a protobuf message could not be encoded to JSON.","ref":"Protox.JsonEncodingError.html","title":"Protox.JsonEncodingError","type":"exception"},{"doc":"This error is thrown when encoding or decoding a Protobuf 2 message with unset required fields (that is, that have the value nil ).","ref":"Protox.RequiredFieldsError.html","title":"Protox.RequiredFieldsError","type":"exception"},{"doc":"protox is an Elixir library to work with Google's Protocol Buffers , versions 2 and 3. It supports both binary and JSON encoding and decoding ( well-known types included, except the Any type for the time being). The primary objective of protox is reliability : it uses property based testing and has a near 100% code coverage . Also, using mutation testing with the invaluable help of Muzak pro , the quality of the protox test suite has been validated. Therefore, protox passes all the tests of the conformance checker provided by Google. It's also easy to use: just point to the *.proto files or give the schema to the Protox macro, no need to generate any file! However, should you need to generate files, a mix task is available . Given the following protobuf definition, protox will generate a Msg struct: message Msg{ int32 a = 1; map&lt;int32, string&gt; b = 2; } You can then interact with Msg like any Elixir structure: iex&gt; msg = % Msg { a : 42 , b : %{ 1 =&gt; &quot;a map entry&quot; } } iex&gt; { :ok , iodata } = Msg . encode ( msg ) iex&gt; { :ok , iodata } = Msg . json_encode ( msg ) iex&gt; binary = # read binary from a socket, a file, etc. iex&gt; { :ok , msg } = Msg . decode ( binary ) iex&gt; json = # read json from a socket, file, etc. iex&gt; { :ok , msg } = Msg . json_decode ( json ) You can find here a more involved example with most types.","ref":"readme.html","title":"Protox","type":"extras"},{"doc":"Prerequisites Installation Usage with a textual description Usage with files Protobuf binary format Protobuf JSON format Packages and namespaces Specify import path Unknown fields Unsupported features Implementation choices Generated code reference Files generation Conformance Types mapping Benchmarks Credits","ref":"readme.html#table-of-contents","title":"Protox - Table of contents","type":"extras"},{"doc":"Elixir &gt;= 1.7 protoc &gt;= 3.0 This dependency is only required at compile-time protox uses Google's protoc (&gt;= 3.0) to parse .proto files. It must be available in $PATH . 👉 You can download it here or you can install it with your favorite package manager ( brew install protobuf , apt install protobuf-compiler , etc.). ℹ️ If you choose to generate files, protoc won't be needed to compile these files.","ref":"readme.html#prerequisites","title":"Protox - Prerequisites","type":"extras"},{"doc":"Add :protox to your list of dependencies in mix.exs : def deps do [ { :protox , &quot;~&gt; 1.6&quot; } ] end If you plan to use the JSON encoding, you'll need to add Jason to your dependencies: def deps do [ { :protox , &quot;~&gt; 1.6&quot; } , { :jason , &quot;~&gt; 1.2&quot; } ] end","ref":"readme.html#installation","title":"Protox - Installation","type":"extras"},{"doc":"The following example generates two modules: Baz and Foo from a textual description: defmodule MyModule do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Baz { } message Foo { int32 a = 1; map&lt;int32, Baz&gt; b = 2; } &quot;&quot;&quot; end ℹ️ The module in which the Protox macro is called is completely ignored and therefore does not appear in the names of the generated modules.","ref":"readme.html#usage-with-an-inlined-textual-description","title":"Protox - Usage with an inlined textual description","type":"extras"},{"doc":"Here's how to generate the modules from a set of files: defmodule MyModule do use Protox , files : [ &quot;./defs/foo.proto&quot; , &quot;./defs/bar.proto&quot; , &quot;./defs/baz/fiz.proto&quot; , ] end","ref":"readme.html#usage-with-files","title":"Protox - Usage with files","type":"extras"},{"doc":"Encode Here's how to create and encode a new message to binary protobuf: iex&gt; msg = % Fiz.Foo { a : 3 , b : %{ 1 =&gt; % Fiz.Baz { } } } iex&gt; { :ok , iodata } = Protox . encode ( msg ) Or, with throwing style: iex&gt; iodata = Protox . encode! ( msg ) It's also possible to call encode/1 and encode!/1 directly on the generated structures: iex&gt; { :ok , iodata } = Fiz.Foo . encode ( msg ) iex&gt; iodata = Fiz.Foo . encode! ( msg ) ℹ️ Note that encode/1 returns an IO data for efficiency reasons. Such IO data can be used directly with files or sockets write operations: iex&gt; { :ok , iodata } = Protox . encode ( % Fiz.Foo { a : 3 , b : %{ 1 =&gt; % Fiz.Baz { } } } ) [ [ [ ] , &lt;&lt; 18 &gt;&gt; , &lt;&lt; 4 &gt;&gt; , &quot; \\b &quot; , &lt;&lt; 1 &gt;&gt; , &lt;&lt; 18 &gt;&gt; , &lt;&lt; 0 &gt;&gt; ] , &quot; \\b &quot; , &lt;&lt; 3 &gt;&gt; ] iex&gt; { :ok , file } = File . open ( &quot;msg.bin&quot; , [ :write ] ) { :ok , # PID &lt; 0 . 1023 . 0 &gt; } iex&gt; IO . binwrite ( file , iodata ) :ok 👉 You can use :binary.list_to_bin/1 or IO.iodata_to_binary to get a binary: iex&gt; % Fiz.Foo { a : 3 , b : %{ 1 =&gt; % Fiz.Baz { } } } |&gt; Protox . encode! ( ) |&gt; :binary . list_to_bin ( ) &lt;&lt; 8 , 3 , 18 , 4 , 8 , 1 , 18 , 0 &gt;&gt; Decode Here's how to decode a message from binary protobuf: iex&gt; { :ok , msg } = Protox . decode ( &lt;&lt; 8 , 3 , 18 , 4 , 8 , 1 , 18 , 0 &gt;&gt; , Fiz.Foo ) Or, with throwing style: iex&gt; msg = Protox . decode! ( &lt;&lt; 8 , 3 , 18 , 4 , 8 , 1 , 18 , 0 &gt;&gt; , Fiz.Foo ) It's also possible to call decode/1 and decode!/1 directly on the generated structures: iex&gt; { :ok , msg } = Fiz.Foo . decode ( &lt;&lt; 8 , 3 , 18 , 4 , 8 , 1 , 18 , 0 &gt;&gt; ) iex&gt; msg = Fiz.Foo . decode! ( &lt;&lt; 8 , 3 , 18 , 4 , 8 , 1 , 18 , 0 &gt;&gt; )","ref":"readme.html#protobuf-binary-format","title":"Protox - Protobuf binary format","type":"extras"},{"doc":"protox implements the Google's JSON specification . Encode Here's how to encode a message to JSON, exported as IO data: iex&gt; msg = % Fiz.Foo { a : 42 } iex&gt; { :ok , iodata } = Protox . json_encode ( msg ) { :ok , [ &quot;{&quot; , [ &quot; \\&quot; a \\&quot; &quot; , &quot;:&quot; , &quot;42&quot; ] , &quot;}&quot; ] } Or, with throwing style: iex&gt; msg = % Fiz.Foo { a : 42 } iex&gt; iodata = Protox . json_encode! ( msg ) [ &quot;{&quot; , [ &quot; \\&quot; a \\&quot; &quot; , &quot;:&quot; , &quot;42&quot; ] , &quot;}&quot; ] It's also possible to call json_encode and json_encode! directly on the generated structures: iex&gt; { :ok , iodata } = Fiz.Foo . json_encode ( msg ) iex&gt; iodata = Fiz.Foo . json_encode! ( msg ) Decode Here's how to decode JSON to a message: iex&gt; Protox . json_decode ( &quot;{ \\&quot; a \\&quot; :42}&quot; , Fiz.Foo ) { :ok , % Fiz.Foo { __uf__ : [ ] , a : 42 , b : %{ } } } Or, with throwing style: iex&gt; Protox . json_decode! ( &quot;{ \\&quot; a \\&quot; :42}&quot; , Fiz.Foo ) % Fiz.Foo { __uf__ : [ ] , a : 42 , b : %{ } } It's also possible to call json_decode and json_decode! directly on the generated structures: iex&gt; Fiz.Foo . json_decode ( &quot;{ \\&quot; a \\&quot; :42}&quot; ) iex&gt; Fiz.Foo . json_decode! ( &quot;{ \\&quot; a \\&quot; :42}&quot; ) JSON library configuration By default, protox uses Jason to encode values to JSON (mostly to escape strings). You can also use Poison : iex&gt; Protox . json_decode! ( iodata , Fiz.Foo , json_library : Protox.Poison ) iex&gt; Protox . json_encode! ( msg , json_library : Protox.Poison ) ℹ️ You can use any other library by implementing the Protox.JsonLibrary behaviour. 👉 Don't forget to add the chosen library to the list of dependencies in mix.exs . Well-known types Note that protox does not completely support the Any well-know type: it will be encoded and decoded like a regular message, rather than with the custom encoding specified in the JSON specification .","ref":"readme.html#protobuf-json-format","title":"Protox - Protobuf JSON format","type":"extras"},{"doc":"Packages Protobuf provides a package directive : package abc.def; message Baz {} Modules generated by protox will include this package declaration. Thus, the example above will be translated to Abc.Def.Baz (note the camelization of package abc.def to Abc.Def ). Prepend namespaces In addition, protox provides the possibility to prepend a namespace to all generated modules: defmodule Bar do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; package abc; message Msg { int32 a = 1; } &quot;&quot;&quot; , namespace : MyApp end In this example, the module MyApp.Abc.Msg is generated: iex&gt; msg = % MyApp.Abc.Msg { a : 42 }","ref":"readme.html#packages-and-namespaces","title":"Protox - Packages and  namespaces","type":"extras"},{"doc":"An import path can be specified using the path: or paths: options that respectively specify the directory or directories in which to search for imports: defmodule Baz do use Protox , files : [ &quot;./defs/prefix/foo.proto&quot; , &quot;./defs/prefix/bar/bar.proto&quot; , ] , path : &quot;./defs&quot; end If multiple search paths are needed: defmodule Baz do use Protox , files : [ &quot;./defs1/prefix/foo.proto&quot; , &quot;./defs1/prefix/bar.proto&quot; , &quot;./defs2/prefix/baz/baz.proto&quot; ] , paths : [ &quot;./defs1&quot; , &quot;./defs2&quot; ] end It corresponds to the -I option of protoc .","ref":"readme.html#specify-import-path","title":"Protox - Specify import path","type":"extras"},{"doc":"Unknown fields are fields that are present on the wire but which do not correspond to an entry in the protobuf definition. Typically, it occurs when the sender has a newer version of the protobuf definition. It makes possible to have backward compatibility as the receiver with an old version of the protobuf definition will still be able to decode old fields. When unknown fields are encountered at decoding time, they are kept in the decoded message. It's possible to access them with the unknown_fields/1 function defined with the message. iex&gt; msg = Msg . decode! ( &lt;&lt; 8 , 42 , 42 , 4 , 121 , 97 , 121 , 101 , 136 , 241 , 4 , 83 &gt;&gt; ) % Msg { a : 42 , b : &quot;&quot; , z : - 42 , __uf__ : [ { 5 , 2 , &lt;&lt; 121 , 97 , 121 , 101 &gt;&gt; } ] } iex&gt; Msg . unknown_fields ( msg ) [ { 5 , 2 , &lt;&lt; 121 , 97 , 121 , 101 &gt;&gt; } ] You must always use unknown_fields/1 as the name of the field (e.g. __uf__ in the above example) is generated at compile-time to avoid collision with the actual fields of the Protobuf message. This function returns a list of tuples {tag, wire_type, bytes} . For more information, please see protobuf encoding guide . When you encode a message that contains unknown fields, they will be reencoded in the serialized output. Disable support of unknown fields You can deactivate the support of unknown fields by setting the :keep_unknown_fields option to false : defmodule Baz do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Sub { int32 a = 1; string b = 2; } &quot;&quot;&quot; , keep_unknown_fields : false end ℹ️ protox will still correctly parse unknown fields, they just won't be added to the structure and you won't be able to access them. This also means that unkown fields won't be serialized back.","ref":"readme.html#unknown-fields","title":"Protox - Unknown fields","type":"extras"},{"doc":"The Any well-known type is partially supported: you can manually unpack the embedded message right after decoding and conversely pack it right before encoding; Groups ( deprecated in protobuf ); All options other than packed and default are ignored as they concern other languages implementation details.","ref":"readme.html#unsupported-features","title":"Protox - Unsupported features","type":"extras"},{"doc":"This library enforces the presence of required fields (Protobuf 2). Therefore an error is raised when encoding or decoding a message with a missing required field: defmodule Bar do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto2&quot;; message Required { required int32 a = 1; } &quot;&quot;&quot; end iex&gt; Protox . encode! ( % Required { } ) ** (Protox.RequiredFieldsError) Some required fields are not set: [:a] iex&gt; Required . decode! ( &lt;&lt; &gt;&gt; ) ** (Protox.RequiredFieldsError) Some required fields are not set: [:a] When decoding enum aliases, the last encountered constant is used. For instance, in the following example, :BAR is always used if the value 1 is read on the wire: enum E { option allow_alias = true; FOO = 0; BAZ = 1; BAR = 1; } Unset optionals For Protobuf 2, unset optional fields are mapped to nil . You can use the generated default/1 function to get the default value of a field: defmodule Bar do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto2&quot;; message Foo { optional int32 a = 1 [default = 42]; } &quot;&quot;&quot; end iex&gt; Foo . default ( :a ) { :ok , 42 } iex&gt; % Foo { } . a nil It means that if you need to know if a field has been set by the sender, you just have to test if its value is nil or not. For Protobuf 3, unset fields are mapped to their default values . However, if you use the optional keyword (available in protoc version 3.15 and higher), then unset fields will be mapped to nil : defmodule Bar do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Foo { int32 a = 1; optional int32 b = 2; } &quot;&quot;&quot; end iex&gt; Foo . default ( :a ) { :ok , 0 } iex&gt; % Foo { } . a 0 iex&gt; Foo . default ( :b ) { :error , :no_default_value } iex&gt; % Foo { } . b nil Messages and enums names: they are converted using the Macro.camelize/1 function. Thus, in the following example, non_camel_message becomes NonCamelMessage , but the field non_camel_field is left unchanged: defmodule Bar do use Protox , schema : &quot;&quot;&quot; syntax = &quot;proto3&quot;; message non_camel_message { } message CamelMessage { int32 non_camel_field = 1; } &quot;&quot;&quot; end iex&gt; msg = % NonCamelMessage { } % NonCamelMessage { __uf__ : [ ] } iex&gt; msg = % CamelMessage { } % CamelMessage { __uf__ : [ ] , non_camel_field : 0 }","ref":"readme.html#implementation-choices","title":"Protox - Implementation choices","type":"extras"},{"doc":"The detailed reference of the generated code is available here .","ref":"readme.html#generated-code-reference","title":"Protox - Generated code reference","type":"extras"},{"doc":"It's possible to generate a file that will contain all code corresponding to the protobuf messages: MIX_ENV=prod mix protox.generate --output-path=/path/to/message.ex --include-path=./test/samples test/samples/messages.proto test/samples/proto2.proto The generated file will be usable in any project as long as protox is declared in the dependencies as it needs functions from the protox runtime. Options --output-path The path to the file to be generated or to the destination folder when generating multiple files. --include-path Specifies the import path . If multiple include paths are needed, add more --include-path options. --multiple-files Generates one file per module. In this case, --output-path must point to a directory. It's useful for definitions with a lot of messages as Elixir will be able to parallelize the compilation of the generated modules. --namespace Prepends a namespace to all generated modules. --keep-unknown-fields=[true|false] Toggles support of unknown fields . Default to true .","ref":"readme.html#files-generation","title":"Protox - Files generation","type":"extras"},{"doc":"The protox library has been thoroughly tested using the conformance checker provided by Google . Here's how to launch the conformance tests: Get conformance-test-runner sources . Compile conformance-test-runner ( macOS and Linux only ): tar xf protobuf - 3.18 . 0 . tar . gz &amp;&amp; cd protobuf - 3.18 . 0 &amp;&amp; . / autogen . sh &amp;&amp; . / configure &amp;&amp; make - j &amp;&amp; cd conformance &amp;&amp; make - j Launch the conformance tests: mix protox . conformance -- runner = / path / to / protobuf - 3.18 . 0 / conformance / conformance - test - runner A report will be generated in the directory conformance_report and the following text should be displayed: CONFORMANCE TEST BEGIN === === === === === === === === === === === === CONFORMANCE SUITE PASSED : 1988 successes , 0 skipped , 29 expected failures , 0 unexpected failures . CONFORMANCE TEST BEGIN === === === === === === === === === === === === CONFORMANCE SUITE PASSED : 0 successes , 120 skipped , 0 expected failures , 0 unexpected failures . You can alternatively launch these conformance tests with mix test by setting the PROTOBUF_CONFORMANCE_RUNNER environment variable and including the conformance tag: PROTOBUF_CONFORMANCE_RUNNER = / path / to / conformance - test - runner MIX_ENV = test mix test -- include conformance Skipped conformance tests You may have noticed that there are 29 expected failures . Indeed, we removed on purpose some conformance tests that protox can't currently pass. Here are the reasons why: Due to a limitation in the DateTime module, it's not possible to have the precision (nanosecond) required by the conformance tests when decoding from JSON; Any is not yet supported by protox ; We could not find the specification for the protobuf2 case of field name extensions when decoding from JSON. The exact list of skipped tests is here .","ref":"readme.html#conformance","title":"Protox - Conformance","type":"extras"},{"doc":"The following table shows how Protobuf types are mapped to Elixir's ones. Protobuf Elixir int32 integer() int64 integer() uint32 integer() uint64 integer() sint32 integer() sint64 integer() fixed32 integer() fixed64 integer() sfixed32 integer() sfixed64 integer() float float() | :infinity | :'-infinity' | :nan double float() | :infinity | :'-infinity' | :nan bool boolean() string String.t() bytes binary() repeated list(value_type) where value_type is the type of the repeated field map map() oneof {atom(), value_type} where atom() is the type of the set field and where value_type is the type of the set field enum atom() | integer() message struct()","ref":"readme.html#types-mapping","title":"Protox - Types mapping","type":"extras"},{"doc":"You can launch benchmarks to see how protox perform: mix run . / benchmarks / generate_payloads . exs # first time only, generates random payloads mix run . / benchmarks / run . exs -- lib = . / benchmarks / protox . exs mix run . / benchmarks / load . exs","ref":"readme.html#benchmarks","title":"Protox - Benchmarks","type":"extras"},{"doc":"Both gpb and exprotobuf were very useful in understanding how to implement Protocol Buffers.","ref":"readme.html#credits","title":"Protox - Credits","type":"extras"},{"doc":"This documentation lists the functions generated with each Elixir structure associated to a protobuf message or enum .","ref":"reference.html","title":"Generated code reference","type":"extras"},{"doc":"Encode @spec encode ( struct ) :: { :ok , iodata } | { :error , any } encode ( msg ) Encode msg into an iodata suitable for files or sockets. Returns {:ok, iodata} when the encoding was successful and {:error, description} in case of an encoding error. @spec encode! ( struct ) :: iodata | no_return encode! ( msg ) Throwing version of encode/1 . Decode @spec decode ( binary ) :: { :ok , struct } | { :error , any } decode ( data ) Decode binary data into an structure with the type of the module on which this function is called. Returns {:ok, msg} when the decoding was successful and {:error, description} in case of an decoding error. @spec decode! ( binary ) :: struct | no_return decode! ( data ) Throwing version of decode/1 . Syntax @spec syntax ( ) :: atom syntax ( ) Get the syntax of the protobuf message: :proto2 or :proto3 . Default values @spec default ( atom ) :: { :ok , boolean | integer | String . t ( ) | binary | float } | { :error , atom } default ( field_name ) Get the default value of a message field. Note that for Protobuf 3, the default value is mandated by the Google reference documentation . Unknown fields Note : these functions are not available when the option :keep_unknown_fields is set to false . @spec clear_unknown_fields ( struct ) :: struct clear_unknown_fields ( msg ) Returns a copy of msg with all unknown fields removed. @spec unknown_fields ( struct ) :: [ { non_neg_integer , Protox.Types . tag ( ) , binary } ] unknown_fields ( msg ) Get the unknown fields that may have been encountered when decoding data. See Types section to get a description of Protox.Types.tag . @spec unknown_fields_name ( ) :: atom unknown_fields_name ( msg ) Get the name of the field that stores unknown fields. Required fields @spec required_fields ( ) :: [ atom ] required_fields ( ) Get the list of required fields.","ref":"reference.html#messages","title":"Generated code reference - Messages","type":"extras"},{"doc":"@spec default ( ) :: atom default ( ) Get the default value of an enum. @spec encode ( atom ) :: integer | atom encode ( enum_entry ) Get the integer value of an enum entry. If enum_entry does not exist in the enum, it is returned as is. @spec decode ( integer ) :: atom | integer decode ( value ) Get the enum entry of an integer value. If value does not correpond to any entry in the enum, it is returned as is. @spec constants ( ) :: [ { integer , atom } ] constants ( ) Get the list of all the constants of the enum that correponds to the module on which this function has been called.","ref":"reference.html#enums","title":"Generated code reference - Enums","type":"extras"},{"doc":"Types Protox.Types.tag , Protox.Types.kind and Protox.Types.type are defined as follows (see here for more details): @type wire_varint :: 0 @type wire_64bits :: 1 @type wire_delimited :: 2 @type wire_32bits :: 5 @type tag :: wire_varint | wire_64bits | wire_delimited | wire_32bits @type kind :: { :scalar , any } | :packed | :unpacked | :map | { :oneof , atom } @type map_key_type :: :int32 | :int64 | :uint32 | :uint64 | :sint32 | :sint64 | :fixed32 | :fixed64 | :sfixed32 | :sfixed64 | :bool | :string @type type :: :fixed32 | :sfixed32 | :float | :fixed64 | :sfixed64 | :double | :int32 | :uint32 | :sint32 | :int64 | :uint64 | :sint64 | :bool | :string | :bytes | { :enum , atom } | { :message , atom } | { map_key_type , type }","ref":"reference.html#types","title":"Generated code reference - Types","type":"extras"}]